<?php
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* PopcornPHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*/
	
	/**
	* Load Logger 
	* Logger file loaded in init.php
	*/
	$LOG		= new Logger();

	/**
	* @string class name to be loaded
	* @return object
	* Note: Class name id case sensitive on some systems!
	*/
	function &load_class($class, $init = true){
		global $LOG;
		static $objects = array();
		
		//check if class has already been loaded through load_class function
		if(isset($objects[$class])){
			return $objects[$class];
		}
		
		//load class file and add element to $objects array
		if(file_exists(APP_ROOT . 'libs' . DS . $class . '.php')){
			require (APP_ROOT . 'libs' . DS . $class . '.php');
		}
		//System library folder
		elseif(file_exists(SYS_ROOT . 'libs' . DS . $class . '.php')){
			require (SYS_ROOT . 'libs' . DS . $class . '.php');
		}
		
		if(!class_exists($class)){
			exit('The class <strong>' . $class . '</strong>  was not found');
		}
		
		if($init){
			$LOG->message('Class initialized "' . $class . '"');
			//load the class
			$objects[$class] = new $class();
			return $objects[$class];
		}else{
			$LOG->message('Class loaded "' . $class . '"');
			//Must return var to satisfy return by reference.
			$bs = '';
			return $bs;
		}
		
		
	} 
	
	
	//Display error message
	function error($message, $header = 'XPF Error:', $template = 'error'){
		$error =& load_class('Error');
		$error->show($message, $header, $template);
	}
	
	function minor_error($message, $template = 'minor_error'){
		$error =& load_class('Error');
		$error->show_minor($message, $template);
	}

	/**
	* Load application config file
	*/
	function load_config($file = 'config'){
		
		if(!file_exists(APP_ROOT . 'config' . DS . $file . '.php')){
			
			error('Config file not found in <strong>' . DS . APP_FOLDER . DS . 'config ' . DS . '</strong>');
			
		}else{
			
			require(APP_ROOT . 'config' . DS . $file . '.php');
			
			if(!isset($config) || !is_array($config)){
				
				error('Your application config file is missing config array');
				
			}
			return $config;
		}
		
	}
	
	
?>