<?php	
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*/	
	
	//XPF Version
	define('XPF_VERSION', '0.6b');

	/*Logger class*/
	require(SYS_ROOT . 'libs' . DS . 'Logger.php');
	
	/*System global functions*/
	require(SYS_ROOT . 'XPF' . DS . 'global.php');
	
	/*Application globals*/
	require(APP_ROOT . 'config' . DS . 'globals.php');

	$LOG->message('****System initialized****');
	
	/**
	* Load Mod class
	*/
	$MOD	=& load_class('Mod');
	
	$MOD->at_point('pre_core');
	
	/**
	* Load core classes of XPF
	*/
	$CNFG	=& load_class('Config');  
	$RTR	=& load_class('Router');
	$DISP	=& load_class('Display');
	
	//Load default app config file
	$CNFG->load();
	
	/*
	* Display PHP errors
	*/
	if($CNFG->item('display_errors') === true){
		ini_set('display_errors', 1);
	}
	
	//Start a session (if not currently set)
	if($CNFG->item('session_auto_start') === true && !isset($_SEESION['XPF_LOADED'])){
		session_start();
		$_SESSION['XPF_LOADED'] = true;
	}

	//Load the base controller class, but dont initiate it yet (that happens in the app controller)
	load_class('Controller', false);
	
	
	if(!file_exists($RTR->root . 'controllers' . DS . $RTR->directory . $RTR->controller . '.php')){ 
		echo $RTR->root;
		//error('Cannot load routed controller! -- Controller: "' . $RTR->directory . $RTR->controller . '.php"');
	}
	
	//Load the application controller 
	//Controller set by URI or default_controller in routes.php
	include($RTR->root . 'controllers' . DS . $RTR->directory . $RTR->controller . '.php');

	/**
	* Load pre-controller mods
	*/
	$MOD->at_point('pre_controller');
	
	if(!class_exists($RTR->controller)){
		error('','','404');
	}
	
	//Load controller class
	$CONT = new $RTR->controller();		
	//Get controller method name
	$method = $RTR->method;

	//Make sure method can be called first before calling it to avoid the embarrassment
	if(!method_exists($CONT,$method)){
		$method = 'index';
	}

	if(!class_exists($RTR->controller)){
		exit('404 Class not Found!');
	}
	
	/**
	* Load post-controller mods
	*/
	$MOD->at_point('post_controller');
	
	//Run the _reroute override function if it exists
	if(method_exists($CONT,'_reroute')){
		$CONT->_reroute($method);
	}else{
		if(method_exists($CONT, $method)){
			//run controller method requested from URI
			call_user_func(array($CONT, $method));
		}else{
			error('Your controller does not have an index() function!');
		}
	}

	$MOD->at_point('post_core');

	if(class_exists('DB_driver')){
		$CONT->db->close_connection();
	}
	
	$LOG->message('****Finished****');
	
?>