<?php
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*/
	
	/**
	* Used for connecting to a database
	*/
	
	class DB_driver {
		
		var $username;
		var $password;
		var $host;
		var $port;
		var $driver;
		var $charset;
		var $conn;//For storing the database connection resource
		var $pconnect = false;
		
		function __construct($params){
			if(is_array($params)){
				foreach($params as $key => $val){
					$this->$key = $val;
				}
			}
		}
		
		function init(){

			//Connection already exists here
			if(is_resource($this->conn)){
				return true;
			}
			
			$this->conn = ($this->pconnect === false)? $this->connect() : $this->pconnect();
			
			//If we can't connect to the database
			if($this->debug){
				if(!isset($this->name) || $this->name == ''){
					echo "No database name specified!";
					return false;
				}
			}
			
			if($this->driver != 'redis'){
				if(!$this->select_db()){
					echo ($this->debug)? "Unable to select database '" . $this->name . "'" : '';
				}
				
				$this->charset = ($this->charset == '' || is_array($this->charset))? 'utf8' : $this->charset;
				
				if(!$this->set_collat($this->collation, $this->charset)){
					return false;
				}
			}
			
			return true;
			
		}
		
		/**
		* Checks if a valid SQL query has been run
		*/
		function check_query(){
			if($this->query == '' || !isset($this->query)){
				if($this->debug){
					error("Cannot fetch SQL row before running a query.", 'SQL Error');
				}
				return false;
			}else{
				return true;
			}
		}
		
		function close_connection(){
		
			if(is_resource($this->conn)){
				$this->close();
			}
			
			$this->conn = false;
			
		}
		
	}
	
	
?>