<?php
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*
	* Base controller
	*/
	
	class mysql_dbdriver extends DB_driver{
		
		var $query = '';
		var $row;
		var $table_list = array();
		
		public function connect(){
			return mysql_connect($this->host, $this->username, $this->password, TRUE);
		}
		
		public function pconnect(){
			return mysql_pconnect($this->host, $this->username, $this->password);
		}
		
		public function select_db(){
			return mysql_select_db($this->name, $this->conn);
		}
		
		public function set_collat($collation, $char_set = 'utf8'){
			return $this->query("SET NAMES `" . $char_set . "` COLLATE '".$this->escape_string($collation)."'");
		}
		
		public function escape_string($str){
			if(function_exists('mysql_real_escape_string')){
				return mysql_real_escape_string($str, $this->conn);
			}else{
				return addslashes($str);
			}
		}
		
		public function version(){
			
			$this->query("SELECT version() as `version`");
			$row = $this->row();
			return $row['version'];
			
		}
		
		/**
		* Return SQL table row
		*/
		public function row($type = 'assoc'){
			
			if($this->check_query() == false){
				return false;
			}else{
			
				if($type == 'assoc'){
					$row = mysql_fetch_assoc($this->query);
				}elseif($type == 'row'){
					$row = mysql_fetch_row($this->query);
				}else{
					$row = mysql_fetch_array($this->query);
				}
				
				$this->row = $row;
				
				return $row;
			}
		}
		
		/**
		* Returns array from query results
		*/
		public function result(){
			
			if(count($this->result) > 0) return $this->result;
			
			$this->result = array();
			
			if($this->query != ''){
				
				while($row = $this->row('assoc')){
					$this->result[] = $row;
				}
				
				return $this->result;
				
			}
			
			return false;
			
		}
		
		/**
		* Get number of rows in a SQL table
		*/
		public function num_rows(){
			if($this->check_query() == false){
				return false;
			}else{
				return mysql_num_rows($this->query);
			}
		}
		
		/**
		* Get list of tables. Return array.
		*/
		public function tables(){
			$tables = array();

			$this->query('SHOW TABLES');
			
			while($row = $this->row('row')){
				$tables[] = $row[0];
			}
			
			return $tables;
		}
		
		/*
		* Returns number of fields for given table
		*/
		function num_fields(){
			
			if($this->query == '') return 0;
			
			return @mysql_num_fields($this->query);
		}
		
		
		/**
		* Get list of columns within a table
		*/
		public function columns($tbl = '*'){
			$cols = array();

			if($tbl == '*'){
				
				$tables = $this->_tables();
				
				foreach($tables as $table){
					$this->query('SHOW COLUMNS FROM ' . $table);
					while($row = $this->row('row')){
						$cols[] = $row[0];
					}
				}
				
				unset($tables);
				
			}else{
				$this->query('SHOW COLUMNS FROM `' . $this->escape_string($tbl) . '`');
				while($row = $this->row('row')){
					$cols[] = $row[0];
				}
			}
			
			return $cols;
			
		}
		
		/*
		* Selects * from a table
		*/
		function rows($table, $limit=0){
			$table = $this->escape_string($table);
			$limit = $this->escape_string($limit);
			
			$limit = ($limit <= 0)? '' : 'LIMIT ' . $limit;
			
			return $this->query("SELECT * FROM `" . $table . "` $limit", true);

		}
		
		/**
		* Backup database schema
		* This function may run slow on large databases.
		*/
		public function backup($table='all'){
			
			$bfile = SYS_ROOT . 'database' . DS . 'backup' . DS . $this->name . '_' . date("Ymd_His") . '.sql';//Backup file
			
			/*
			* Backup entire database into .sql file framework/backup
			*/
			if($table == 'all'){
				
				$tables = $this->tables();
				
				foreach($tables as $table) {
					
					
					
				}

				
				return true;
			}
			
			/*
			* Backup specific table only
			*/
			if(ctype_alpha($table)){
				
				$table = $this->escape_string($table);
				$this->query("SELECT * INTO OUTFILE '$bfile' FROM $table");
				
				return true;
			
			}
			
			return false;
			
		}
		
		/**
		* Restore a backup file
		*/
		public function restore(){
			//TODO
		}
		
		
		
		/*
		* MySQL number of affected rows from last query
		*/
		public function affected_rows(){
			
			if($this->query == ""){
				return 0;
			}
			
			return (int)mysql_affected_rows($this->query);
		}
		
		/*
		* returns length of each row in array that was returned from prev. mysql_fetch_*() statement
		* Note: who the hell uses this?
		*/
		public function lengths(){
			if($this->query == ""){
				return 0;
			}
			
			$arr = mysql_fetch_lengths($this->query);
			
			if(count($arr) > 0){
				return $arr;
			}
			
			return 0;
			
		}
		
		/*
		* Check database connection
		*/
		public function ping(){
			
			if($this->conn == false) return false;
			
			return @mysql_ping($this->conn);
		}
		
		/*
		* Returns information on MySQL threads
		*/
		public function list_processes(){
		
			$this->query = mysql_list_processes($this->conn);
			
			while ($row = $this->row()){
				
				echo "Process: " . $row['Id'] . ' -- Host: ' . $row['Host'] . ' -- DB: ' . $row['db']
					. ' -- Command: ' . $row['Command'] . ' -- Time: ' . $row['Time'] . '<br/>';
				
			}
			
			$this->free_result();
		}
		
		/*
		* Free memory allocated from the result command
		*/
		function free_result(){
			
			if($this->check_query()){	
				return @mysql_free_result($this->query);
			}
			
			return false;
			
		}
		

		/**
		* Run SQL query
		*/
		public function query($sql, $return = false){
			
			if($sql == ''){
				if($this->debug){
					error("Invalid SQL query");
				}
				return false;
			}
			
			$this->query = mysql_query($sql, $this->conn) or die(error(mysql_error(), 'SQL Error'));
			$this->result = array();//clear result cache
			
			if($return){
				return $this->query;
			}
		}
		
		/**
		* Update row
		*/
		public function update($cols, $vals, $table='', $where=''){
			
			$colarg = '';
			
			if($table == ''){
				return false;
			}
			
			if(is_array($cols)){
				if(!is_array($vals)){
					error("SQL Update; array given for columns but not for values for table \"" . $table . "\"");
					return false;
				}
				
				$i=0;
				foreach($cols as $col => $val){
					$colarg .= 'SET `' . $val . '`=\'' . $vals[$i] . '\', ';
					$i++;
				}
				
				$colarg = substr($colarg, 0, -2);
				
			}else{
				$colarg = 'SET `' . $cols . '`=\'' . $vals . '\'';
			}
			
			$where = ($where != '')? ' WHERE ' . $where : '';
			
			return $this->query("UPDATE " . $table . " SET " . $colarg . $where);
			
		}
		
		/*
		* Fixes the index id columns of a table to be 1-x
		*
		* Example: you have a table with 5 rows with auto incrimenting`id` columns 
		* and they are listed as "1,4,5,9,2". This function will arrange them to read "1,2,3,4,5"
		*
		* Especially good for OCD people...
		*/
		public function organize_index($table){
			if($table == null || $table == '') error("Undefined table given. DB::organize_index()", "SQL Error: ");
			
			$table = $this->escape_string($table);
			
			$this->query("SELECT `id` FROM `" . $table . "` ORDER BY `id` ASC");
			
			$current = 1;
			foreach($this->result() as $row){
				
				$this->query("UPDATE `" . $table . "` SET `id`='" . $current . "' WHERE `id`='" . $row['id'] . "'");
				$current += 1;
				
			}
			
			return true;
			
		}
		
		/**
		* Close MySql connection
		*/
		public function close(){
			mysql_close($this->conn);
			$this->conn = false;
		}
		
	}
	
?>