<?php	
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*/	
	
	/*
	* Load configuration files
	*/
	
	class Config {
		
		var $config = array();
		
		function __construct(){
			//config array from app/config/config.php
			//load_config function defined in XPF/global.php
			$this->config	= load_config();
		}
		
		//load config file
		public function load($file = ''){
			
			//config file name
			$file = ($file == '')? 'config' : str_replace('.php','',$file);
			
			//if config file is not found
			if(!file_exists(APP_ROOT . 'config' . DS . $file .'.php')){
				
				error('Configuration file "'. $file . '" not found.');
			
			}else{
				
				include(APP_ROOT . 'config' . DS . $file .'.php');
				
				if(!isset($config) || !is_array($config)){
					error('Your config file does not contain a config array.','Configuration Error: ');
				}
				$this->config = array_merge($this->config, $config);
			}
			
		}
		
		/**
		* Retreives config 'site_url' or attempts to automatically find the sites base url
		* TODO:
		* - Automatically find site directory in a sub folder.
		*/
		public function site_url($sub=false, $uri=''){
			$folder = (substr($this->item('folder'), -1) == '/' && $this->item('folder') != '')? $this->item('folder') : $this->item('folder');
			
			if(strtoupper($this->item('site_url')) == 'AUTO' || $this->item('site_url') == ''){
				$url = 'http://' . $_SERVER['HTTP_HOST'];
				
				if($sub === true){
					$url .= $_SERVER['REQUEST_URI'];
				}else{
					$url .= '/';
				}
				
				return $url . $folder . trim($uri , '/');
				
			}else{
				//Get set URL
				$url = $this->item('site_url');
				
				//Add a trailing slash
				$url = (substr($url, -1) == '/')? $url : $url . '/';
				
				return $url . $folder . trim($uri , '/');
			}
		}
		
		//Retreive a config item from one of the config arrays in app/config/*.php
		public function item($item){
			if(isset($this->config[$item])){
				return $this->config[$item];
			}
			return '';
		}
		
	}
?>