<?php
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*/
	
	
	class Error {
		
		var $show_error;
		var $ob_level;
		
		function __construct(){
			
			$this->config = load_class('Config');
			$this->ob_level = ob_get_level();
			
		}
		
		/*
		* Display custom fatal error 
		* Note: errors will not be shown while the config item "display_errors" is false
		*		see "Error:show_minor()"
		*/
		public function show($message, $error = 'Error: ', $template = 'error'){
			
			/**
			* Don't do anything if display_errors is off
			*/
			if($this->config->item('display_errors') === false){
				return false;
			}
			
			$message = ($message == '' | empty($message) ) ? 'Unspecified error has occured' : '<p>' . $message . '</p>';
			
			$template = (file_exists(APP_ROOT . 'errors' . DS . $template . '.php'))? APP_ROOT . 'errors' . DS . $template . '.php' : '';
			
			$buffer = 'Error';
			
			//Clear current buffer if it exists
			if(ob_get_level() > 0){
				ob_end_clean();
			}
			
			if($template != ''){
				include($template);
			}
			
			die();
		}
		
		//Displays custom error message to the user
		public function show_minor($message, $template='minor_error'){
			
			$template = (file_exists(APP_ROOT . 'errors' . DS . $template . '.php'))? APP_ROOT . 'errors' . DS . $template . '.php' : '';
			
			if($template != ''){
				include($template);
				return;
			}
			
			echo $message;
			return;
		}
		
	}
	
?>