<?php
	
	if(!defined('SYS_ROOT')){exit('No direct file access allowed!');}
	
	/**
	* Xtron PHP Framework
	* A MVC style framework for building web applications
	* By: Jason Alan Delaney (http://www.xtroncms.com)
	* PHP version 5+
	*
	*/

	/**
	* E-Mail class
	*/
	
	/**
	* TODO:
	* - Function to setup mail ports, servers, and other settings
	* - SMTP Authentication and SSL 
	*/
	
	class Mail {
		
		var $to;//Send to email
		var $from;//Sent from email
		var $set;
		
		function __construct(){
			$this->config =& load_class('Config');
			//load the mail config file
			$this->config->load('mail');
			
			if(class_exists('Validator')){
				$xpf =& controller_instance();
				$this->validate =& $xpf->validator;
			}else{
				$this->validate =& load_class('Validator');
			}			
			
			if($this->set < 1){
				$this->_setup();
			}
		}
		
		
		private function _setup(){
			
			$this->to 	= $this->config->item('to_email');
			$this->from = $this->config->item('from_email');
			
			if($this->from != '') ini_set('sendmail_from', $this->from);
			
			$this->set = 1;
			
		}
		
		//Send an email
		public function send($msg, $subj, $to='default', $loc=null, $oemails=array()){
			
			//Recipients email (reverts to email defined in mail.php in app/config/)
			$this->to = ($to == 'default')? $this->to : (string)$to;
			
			$this->to = strip_tags(trim($this->to));
			
			//Vali d email?
			if($this->validate->is_valid_email($this->to)){
				
				$headers = "From: " . $this->from . "\r\n";
				$headers .= "MIME-Version: 1.0\r\n";

				//Send to multiple emails?
				if(count($oemails) > 0){
					$headers .= 'CC: ';
					foreach($oemails as $email){
						if($this->validate->is_valid_email($email)){
							$headers .= $email . ',';
						}
					}
					$headers .= '\n';
				} 
				
				$headers .= "Content-Type: text/html; charset=ISO-8859-1\n";
				$headers .= "Reply-To: " . $this->from . "\r\n";
				$headers .= "Return-Path: " . $this->from . "\r\n";
				$headers .= "X-Mailer: PHP". phpversion(); 
				
				$msg = urldecode('<body>' . $msg . '</body>');
				
				//Send the message and redirect or resresh the page
				if(mail($this->to, $subj, $msg, $headers)){
					if($loc != null){
						header("Refresh:0;url=" . $loc);
					}
				}else{
				
					error("Error sending mail. Make sure you have sendmail installed if your are running a Linux machine.", "Mail Error: ");
				
				}
				
			}else{
				
				error("Invalid email '" . $this->to . "' check mail config file or the php.ini sendmail_path settings. ");
				
			}
			
		}
		
		
	}
	
?>